using System;
using System.Linq;
using System.Security.Principal;
using System.Threading;
using System.Web;
using System.Web.Caching;

namespace WcfRestServiceDemo.Service
{
    internal class CustomPrincipal : IPrincipal
    {
        private readonly IIdentity _identity;

        public CustomPrincipal(IIdentity identity)
        {
            _identity = identity;
        }

        /// <summary>
        /// Gets the <see cref="CustomPrincipal"/> instance for the current user.
        /// It's a helper method for easy access (without casting).
        /// </summary>
        public static CustomPrincipal Current
        {
            get { return Thread.CurrentPrincipal as CustomPrincipal; }
        }

        public string[] Roles
        {
            get { return System.Web.Security.Roles.GetRolesForUser(_identity.Name); }
        }

        #region IPrincipal Members

        public IIdentity Identity
        {
            get { return _identity; }
        }

        public bool IsInRole(string role)
        {
            return Roles.Contains(role);
        }

        #endregion
    }
}